# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse20014(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'str',
        'failure_message': 'str',
        'input_properties': 'dict(str, object)',
        'output_properties': 'dict(str, object)',
        'tasks': 'list[BlueprintExecutionTasks]'
    }

    attribute_map = {
        'status': 'status',
        'failure_message': 'failureMessage',
        'input_properties': 'inputProperties',
        'output_properties': 'outputProperties',
        'tasks': 'tasks'
    }

    def __init__(self, status=None, failure_message=None, input_properties=None, output_properties=None, tasks=None):  # noqa: E501
        """InlineResponse20014 - a model defined in Swagger"""  # noqa: E501
        self._status = None
        self._failure_message = None
        self._input_properties = None
        self._output_properties = None
        self._tasks = None
        self.discriminator = None
        if status is not None:
            self.status = status
        if failure_message is not None:
            self.failure_message = failure_message
        if input_properties is not None:
            self.input_properties = input_properties
        if output_properties is not None:
            self.output_properties = output_properties
        if tasks is not None:
            self.tasks = tasks

    @property
    def status(self):
        """Gets the status of this InlineResponse20014.  # noqa: E501

        Blueprint execution status  # noqa: E501

        :return: The status of this InlineResponse20014.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this InlineResponse20014.

        Blueprint execution status  # noqa: E501

        :param status: The status of this InlineResponse20014.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREATED", "STARTED", "FINISHED", "FAILED", "CANCELLED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def failure_message(self):
        """Gets the failure_message of this InlineResponse20014.  # noqa: E501

        Blueprint execution failure message  # noqa: E501

        :return: The failure_message of this InlineResponse20014.  # noqa: E501
        :rtype: str
        """
        return self._failure_message

    @failure_message.setter
    def failure_message(self, failure_message):
        """Sets the failure_message of this InlineResponse20014.

        Blueprint execution failure message  # noqa: E501

        :param failure_message: The failure_message of this InlineResponse20014.  # noqa: E501
        :type: str
        """

        self._failure_message = failure_message

    @property
    def input_properties(self):
        """Gets the input_properties of this InlineResponse20014.  # noqa: E501

        Blueprint execution input properties  # noqa: E501

        :return: The input_properties of this InlineResponse20014.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._input_properties

    @input_properties.setter
    def input_properties(self, input_properties):
        """Sets the input_properties of this InlineResponse20014.

        Blueprint execution input properties  # noqa: E501

        :param input_properties: The input_properties of this InlineResponse20014.  # noqa: E501
        :type: dict(str, object)
        """

        self._input_properties = input_properties

    @property
    def output_properties(self):
        """Gets the output_properties of this InlineResponse20014.  # noqa: E501

        Blueprint execution output properties  # noqa: E501

        :return: The output_properties of this InlineResponse20014.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._output_properties

    @output_properties.setter
    def output_properties(self, output_properties):
        """Sets the output_properties of this InlineResponse20014.

        Blueprint execution output properties  # noqa: E501

        :param output_properties: The output_properties of this InlineResponse20014.  # noqa: E501
        :type: dict(str, object)
        """

        self._output_properties = output_properties

    @property
    def tasks(self):
        """Gets the tasks of this InlineResponse20014.  # noqa: E501

        Blueprint execution tasks  # noqa: E501

        :return: The tasks of this InlineResponse20014.  # noqa: E501
        :rtype: list[BlueprintExecutionTasks]
        """
        return self._tasks

    @tasks.setter
    def tasks(self, tasks):
        """Sets the tasks of this InlineResponse20014.

        Blueprint execution tasks  # noqa: E501

        :param tasks: The tasks of this InlineResponse20014.  # noqa: E501
        :type: list[BlueprintExecutionTasks]
        """

        self._tasks = tasks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20014, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20014):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
